package diet;


public class Menu implements NutritionalElement {

	private String name;
	private Food food;
	double calories = 0.0;
	double proteins = 0.0;
	double carbs = 0.0;
	double fat = 0.0;

	/**
	 * Creates a menu
	 * 
	 * @param name the name of the menu
	 * @param food the food object containing the information about raw materials 
	 */
	public Menu(String name, Food food){
		this.name = name;
		this.food = food;
	}
	
	public void addRecipe(String recipe, double quantity) {
		NutritionalElement ric = food.getRecipe(recipe);
			
		calories += ric.getCalories() * quantity / 100.0;
		proteins += ric.getProteins() * quantity / 100.0;
		carbs += ric.getCarbs() * quantity / 100.0;
		fat += ric.getFat() * quantity / 100.0;
	}

	public void addProduct(String product) {
		NutritionalElement prod = food.getProduct(product);
			
		calories += prod.getCalories();
		proteins += prod.getProteins();
		carbs += prod.getCarbs();
		fat += prod.getFat();
	}

	public String getName() {
		return name;
	}

	/**
	 * KCal totali del menu
	 */
	public double getCalories() {
		return calories;
	}

	/**
	 * grammi di proteine  totali del men
	 */
	public double getProteins() {
		return proteins;
	}

	/**
	 * grammi di carboidrati totali del men
	 */
	public double getCarbs() {
		return carbs;
	}

	/**
	 * grammi di grassi totali del men
	 */
	public double getFat() {
		return fat;
	}

	public boolean per100g() {
		return false;
	}
}
