package diet;

import java.util.LinkedList;

public class Recipe implements NutritionalElement {
    private String name;
    private Food food;
    private LinkedList<Ingredient> ingredients = new LinkedList<Ingredient>();
    double calories = 0.0;
    double proteins = 0.0;
    double carbs = 0.0;
    double fat = 0.0;
    double weight = 0.0;
    
    private class Ingredient {
    	NutritionalElement en;
    	double qty;
    }
    
	public Recipe(String name, Food food){
		this.name = name;
		food.addRicetta(this);
		this.food = food;
	}
	
	public void addIngredient(String material, double quantity) {
		Ingredient ing = new Ingredient();
		ing.qty = quantity;
		ing.en = food.getRawMaterial(material);
			
		calories += ing.en.getCalories() * ing.qty / 100.0;
		proteins += ing.en.getProteins() * ing.qty / 100.0;
		carbs += ing.en.getCarbs() * ing.qty / 100.0;
		fat += ing.en.getFat() * ing.qty / 100.0;
		weight += quantity;
		
		ingredients.add(ing);
	}

	public String getName() {
		return name;
	}

	public double getCalories() {
		return calories *100/weight;
	}

	public double getProteins() {
		return proteins *100/weight;
	}

	public double getCarbs() {
		return carbs *100/weight;
	}

	public double getFat() {
		return fat *100/weight;
	}

  public boolean per100g() {
    return true;
  }

}
