package it.polito.po.test;
import java.util.Collection;
import java.util.Iterator;

import diet.*;
import junit.framework.TestCase;


public class TestR2_Products extends TestCase {

  public TestR2_Products(String arg0) {
    super(arg0);
  }

  public void testDefinizione(){
  	Food dieta = new Food();
  	
  	int initialSize = dieta.products().size();
  	dieta.defineProduct("Cracker", 111, 2.6, 17.2, 3.5);
	int finalSize = dieta.products().size();
	
	assertEquals(0,initialSize);
	assertEquals(1,finalSize);
  }
  
  public void testCollezioneProdotti(){
	Food dieta = new Food();
  	
	dieta.defineProduct("Cracker", 111, 2.6, 17.2, 3.5);
	
	Collection<NutritionalElement> c = dieta.products();
	
	NutritionalElement en = (NutritionalElement)c.iterator().next();
	
	assertEquals("Cracker",en.getName());
	assertEquals(111,en.getCalories(),0.001); 
	assertEquals(2.6,en.getProteins(),0.001); 
	assertEquals(17.2,en.getCarbs(),0.001); 
	assertEquals(3.5,en.getFat(),0.001); 
	assertFalse(en.per100g());
  }

  public void testProdotto(){
	Food dieta = new Food();
	dieta.defineProduct("Cracker", 111, 2.6, 17.2, 3.5);
	NutritionalElement en = dieta.getProduct("Cracker");
	
	assertEquals("Cracker",en.getName());
	assertEquals(111,en.getCalories(),0.001); 
	assertEquals(2.6,en.getProteins(),0.001); 
	assertEquals(17.2,en.getCarbs(),0.001); 
	assertEquals(3.5,en.getFat(),0.001); 
	assertFalse(en.per100g());
  }
  
  public void testCollezioneProdottiOrdine(){
	Food dieta = new Food();
  	
	dieta.defineProduct("Zucchero", 400, 0, 100, 0);
	dieta.defineProduct("Mais", 70, 2.7, 12, 1.3);
	dieta.defineProduct("Pasta", 350, 12, 72.2, 1.5);
	
	Collection<NutritionalElement> c = dieta.products();
	Iterator<NutritionalElement> it = c.iterator();
	NutritionalElement first = (NutritionalElement)it.next();
	NutritionalElement second = (NutritionalElement)it.next();
	NutritionalElement third = (NutritionalElement)it.next();
	
	assertEquals("Mais",first.getName());
	assertEquals("Pasta",second.getName());
	assertEquals("Zucchero",third.getName());
  }

}
