package it.polito.po.test;
import diet.*;
import junit.framework.TestCase;

public class TestR4_Menu extends TestCase {

  public TestR4_Menu(String arg0) {
    super(arg0);
  }

  private Food alimenti;
  private Recipe r;

  public void setUp() throws Exception {
    alimenti = new Food();
    alimenti.defineRawMaterial("Zucchero", 400, 0, 100, 0);
    alimenti.defineRawMaterial("Mais", 70, 2.7, 12, 1.3);
    alimenti.defineRawMaterial("Pasta", 350, 12, 72.2, 1.5);
    alimenti.defineRawMaterial("Olio", 900, 0, 0, 100);
    alimenti.defineRawMaterial("Nutella", 530, 6.8, 56, 31);
	alimenti.defineProduct("Cracker", 111, 2.6, 17.2, 3.5);
    r = new Recipe("Pasta e Nutella", alimenti);
    r.addIngredient("Pasta", 70);
    r.addIngredient("Nutella", 30);
  }

  public void testMenuConRicetta() {
    Menu menu = new Menu("M1", alimenti);

    menu.addRecipe("Pasta e Nutella", 100);

    assertEquals(350 * 0.7 + 530 * 0.3, r.getCalories(), 0.001);
    assertEquals(12 * 0.7 + 6.8 * 0.3, r.getProteins(), 0.001);
    assertEquals(72.2 * 0.7 + 56 * 0.3, r.getCarbs(), 0.001);
    assertEquals(1.5 * 0.7 + 31 * 0.3, r.getFat(), 0.001);
  }

  public void testMenu() {
    Menu menu = new Menu("M1", alimenti);

    menu.addRecipe("Pasta e Nutella", 50);
    menu.addProduct("Cracker");

    assertEquals(350 * 0.35 + 530 * 0.15 + 111, menu.getCalories(), 0.001);
    assertEquals(12 * 0.35 + 6.8 * 0.15 + 2.6, menu.getProteins(), 0.001);
    assertEquals(72.2 * 0.35 + 56 * 0.15 + 17.2, menu.getCarbs(), 0.001);
    assertEquals(1.5 * 0.35 + 31 * 0.15 + 3.5, menu.getFat(), 0.001);
  }

}
